#pragma once

#include <jlog/ansi_escape_codes.hpp>

// Platform independent color code mapping

struct colorcode
{
    std::string ansi_code;
};

namespace jlog::color_codes
{
    static const colorcode FG_BLACK     {ansi_escape_codes::FG_BLACK};
    static const colorcode FG_RED       {ansi_escape_codes::FG_RED};
    static const colorcode FG_GREEN     {ansi_escape_codes::FG_GREEN };
    static const colorcode FG_YELLOW    {ansi_escape_codes::FG_YELLOW};
    static const colorcode FG_BLUE      {ansi_escape_codes::FG_BLUE};
    static const colorcode FG_MAGENTA   {ansi_escape_codes::FG_MAGENTA};
    static const colorcode FG_CYAN      {ansi_escape_codes::FG_CYAN};
    static const colorcode FG_WHITE     {ansi_escape_codes::FG_WHITE};
    static const colorcode FG_DEFAULT   {ansi_escape_codes::FG_DEFAULT};

    static const colorcode FG_BRIGHT_BLACK {ansi_escape_codes::FG_BRIGHT_BLACK};
    static const colorcode FG_BRIGHT_RED {ansi_escape_codes::FG_BRIGHT_RED};
    static const colorcode FG_BRIGHT_GREEN {ansi_escape_codes::FG_BRIGHT_GREEN};
    static const colorcode FG_BRIGHT_YELLOW {ansi_escape_codes::FG_BRIGHT_YELLOW};
    static const colorcode FG_BRIGHT_BLUE {ansi_escape_codes::FG_BRIGHT_MAGENTA};
    static const colorcode FG_BRIGHT_MAGENTA {ansi_escape_codes::FG_BRIGHT_MAGENTA};
    static const colorcode FG_BRIGHT_CYAN {ansi_escape_codes::FG_BRIGHT_CYAN};
    static const colorcode FG_BRIGHT_WHITE {ansi_escape_codes::FG_BRIGHT_WHITE};

    static const colorcode BG_BLACK {ansi_escape_codes::BG_BLACK};
    static const colorcode BG_RED {ansi_escape_codes::BG_RED};
    static const colorcode BG_GREEN {ansi_escape_codes::BG_GREEN};
    static const colorcode BG_YELLOW {ansi_escape_codes::BG_YELLOW};
    static const colorcode BG_BLUE {ansi_escape_codes::BG_BLUE};
    static const colorcode BG_MAGENTA {ansi_escape_codes::BG_MAGENTA};
    static const colorcode BG_CYAN {ansi_escape_codes::BG_CYAN};
    static const colorcode BG_WHITE {ansi_escape_codes::BG_WHITE};
    static const colorcode BG_DEFAULT {ansi_escape_codes::BG_DEFAULT};

    static const colorcode BG_BRIGHT_BLACK {ansi_escape_codes::BG_BRIGHT_BLACK};
    static const colorcode BG_BRIGHT_RED {ansi_escape_codes::BG_BRIGHT_RED};
    static const colorcode BG_BRIGHT_GREEN {ansi_escape_codes::BG_BRIGHT_GREEN};
    static const colorcode BG_BRIGHT_YELLOW {ansi_escape_codes::BG_BRIGHT_YELLOW};
    static const colorcode BG_BRIGHT_BLUE {ansi_escape_codes::BG_BRIGHT_BLUE};
    static const colorcode BG_BRIGHT_MAGENTA {ansi_escape_codes::BG_BRIGHT_MAGENTA};
    static const colorcode BG_BRIGHT_CYAN {ansi_escape_codes::BG_BRIGHT_CYAN};
    static const colorcode BG_BRIGHT_WHITE {ansi_escape_codes::BG_BRIGHT_WHITE};
}